package obd.dacia.renault;

import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.view.View;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.Toast;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.os.AsyncTask;


import java.io.IOException;
import java.util.UUID;


public class obdControl extends ActionBarActivity {

    Button btnfin, btntrennen ,btntest;

    ImageButton btndacia, btnrenault ;

    String address = null;
    private ProgressDialog progress;
    BluetoothAdapter myBluetooth = null;
    BluetoothSocket btSocket = null;
    private boolean isBtConnected = false;
    static final UUID myUUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        Intent newint = getIntent();
        address = newint.getStringExtra(DeviceList.EXTRA_ADDRESS);

        /* Seite  */
        setContentView(R.layout.activity_obd_control);

        /* Tasten  */
        btnfin             = (Button) findViewById(R.id.b_fin);
        btntest             = (Button) findViewById(R.id.b_test);

        btntrennen         = (Button) findViewById(R.id.b_trennen);
        btndacia           = (ImageButton) findViewById(R.id.b_dacia);
        btnrenault         = (ImageButton) findViewById(R.id.b_renault);

        new ConnectBT().execute();


        btnfin.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                fin_auslesen();
            }
        });

        btntest.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                setContentView(R.layout.activity_obd_dacia);
                test_daten_senden();
            }
        });
        btntrennen.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                trennen();
            }
        });

        btndacia.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                setContentView(R.layout.activity_obd_dacia);
            }
        });
        btnrenault.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                setContentView(R.layout.activity_obd_renault);
            }
        });

    }

    private void fin_auslesen()
    {
        if (btSocket != null)
        {
            try
            {
                btSocket.getOutputStream().write("ID: 743 00 00 00 00 00 00 00 00".toString().getBytes());
                btSocket.getOutputStream().write(0x0a);
            }
            catch (IOException e)
            {
                msg("Error");
            }
        }
    }

    private void test_daten_senden()
    {
        if (btSocket != null)
        {
            try
            {
                btSocket.getOutputStream().write("ID: 743 00 00 00 00 00 00 00 00".toString().getBytes());
                btSocket.getOutputStream().write(0x0a);
            }
            catch (IOException e)
            {
                msg("Error");
            }
        }
    }

    private void trennen()
    {
        if (btSocket != null)
        {
            try
            {
                btSocket.close();
            }
            catch (IOException e)
            {  msg("Error"); }
        }
        finish();

    }

    private void msg(String s)
    {
        Toast.makeText(getApplicationContext(), s, Toast.LENGTH_LONG).show();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_obd_control, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();

        if (id == R.id.action_settings) {

            return true;
        }

        return super.onOptionsItemSelected(item);
    }


    private class ConnectBT extends AsyncTask<Void, Void, Void>  // UI thread
    {
        private boolean ConnectSuccess = true; //if it's here, it's almost connected

        @Override
        protected void onPreExecute() {
            progress = ProgressDialog.show(obdControl.this, "Verbinde...", "Bitte Warten !!!");  //show a progress dialog
        }

        @Override
        protected Void doInBackground(Void... devices) //while the progress dialog is shown, the connection is done in background
        {
            try {
                if (btSocket == null || !isBtConnected) {
                    myBluetooth = BluetoothAdapter.getDefaultAdapter();
                    BluetoothDevice dispositivo = myBluetooth.getRemoteDevice(address);
                    btSocket = dispositivo.createInsecureRfcommSocketToServiceRecord(myUUID);
                    BluetoothAdapter.getDefaultAdapter().cancelDiscovery();
                    btSocket.connect();
                }
            }
            catch (IOException e)
            {
                ConnectSuccess = false;
            }
            return null;
        }

        @Override
        protected void onPostExecute(Void result) //after the doInBackground, it checks if everything went fine
        {
            super.onPostExecute(result);

            if (!ConnectSuccess) {
                msg("Verbindung fehlgeschlagen. Ist es ein SPP Bluetooth? Versuchen Sie es noch einmal");
                finish();
            } else {
                msg("Verbunden.");
                isBtConnected = true;
            }
            progress.dismiss();
        }
    }
}
